var bingo = bingo || {
	
    config: {
        spielModus: 'klassisch',
        gegnerAnzahl: 10,
        ZeitAbstandZiehung: 10,
        AnzahlBingoKarten: 2,
        SpielHilfe: 'off',
        configUeberpruefung: false,
        geladen: false,
        gameover: false,
        benoetigteBingos: 4,
        animationCheck: false,
        randomColor: "rgb(0,150,0)"
    },
    
    data: {
        drawnNumbers: new Array(),
        basis: 0,
        nummer: 0,
        zahlenReihenfolge: new Array(),
        gegnerWin: new Array(),
        spielerWin: new Array(),
        alreadyMarked: new Array(),
        markedNumbers: new Array(),
        muster:			new Array(),
        bingos: 		new Array(),
        anzahlBingos: 0,
        marked:		false,
        bingo:  new Array("B","I","N","G","O")
    },
    
    init: function () {
        bingo.bindings();
    },
    
    injektions: function () {
    },
     
    bindings: function () {
    	
    	$('#benoetigteBingos').change(function(){
    		bingo.config.benoetigteBingos = this.value;
    	});
    	
    	$('#spielModus').change(function(){
    		bingo.config.spielModus = this.value;
    		console.log(bingo.config.spielModus);
    	});
    	
    	$('#computerSpieler').change(function(){
    		var test = this.value;
    		bingo.config.gegnerAnzahl = parseInt(test);
    		console.log(bingo.config.gegnerAnzahl);
    	});
    	
    	$('#zeitAbstand').change(function(){
    		var test = this.value;
    		bingo.config.ZeitAbstandZiehung= parseInt(test);
    		console.log(bingo.config.ZeitAbstandZiehung);
    	});
    	
    	$('#bingoKarten').change(function(){
    		var test = this.value;
    		bingo.config.AnzahlBingoKarten = parseInt(test);
    		console.log(bingo.config.AnzahlBingoKarten);
    	});
    	
    	$('#Spielhilfe').change(function(){
    		bingo.config.SpielHilfe = (this.form.Spielhilfe.checked ? this.form.Spielhilfe.value : 'off')
    		console.log(bingo.config.SpielHilfe);
    	});
    	  	 	
       	$('#zeigeOptionen').click(function(){
       		if($('#spielOptionen').hasClass('animated')){
       			$('#spielOptionen').dequeue().stop();
       		}
       		$('#spielOptionen').addClass('animated');
    		$('#spielOptionen').toggle(
    	    		function(){
    	    			$('#spielOptionen').removeClass('animated');
    	    		});
    	});
    	
        $('#spielen').click(function () {
            if (bingo.ueberpruefeConfig()) {
            	var bild = 'images/tischplatte.JPG';
            	$("#startGrafik").attr('src',bild);
            	$("#startGrafik").css('margin',0);
                if ($('#Spieloberflaeche').css('display') == 'none') {
                    $('#Spieloberflaeche').css('display', 'block');
                    $('#Hauptmenu').css('display', 'none');
                }
                bingo.spielen();
            }
        });         
    },
    
    spielen: function() {
    	bingo.data.zahlenReihenfolge = bingo.bestimmeZahlenReihenfolge(bingo.data.zahlenReihenfolge);
        if (bingo.config.geladen == true) {
        	if(bingo.config.spielModus == 'Muster'){
        		bingo.createPatternCard();
          	}
          	bingo.erstelleSpieler();
          	bingo.KugelAnimation(0);
          	bingo.progressbar();
        }
    },
    
    ueberpruefeConfig: function () {
        if (bingo.config.spielModus == 'klassisch' || bingo.config.spielModus == 'FullCard' || bingo.config.spielModus == 'Muster' || bingo.config.spielModus == 'Hervorgehoben' || bingo.config.spielModus == 'Erreiche Bingos') {
            console.log('Gamemode allowed');
            if (parseInt(bingo.config.gegnerAnzahl) < 101) {
                console.log('Number of Enemys allowed');
                if (parseInt(bingo.config.ZeitAbstandZiehung) > 9 && parseInt(bingo.config.ZeitAbstandZiehung) < 16) {
                    console.log('Delay between new draw allowed');
                    if (parseInt(bingo.config.AnzahlBingoKarten) > 0 && parseInt(bingo.config.AnzahlBingoKarten) < 11) {
                        console.log('Number of cards allowed');
                        if (bingo.config.SpielHilfe == 'off') {
                            console.log('everything ok, start Game');
                            bingo.config.configUeberpruefung = true;
                            return true;
                        }
                        if (bingo.config.SpielHilfe == 'on') {
                            console.log('everything ok, start game with help');
                            bingo.config.configUeberpruefung = true;
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    },
   
    erstelleSpieler: function () {
        for (var i = 0; i < parseInt(bingo.config.AnzahlBingoKarten); i++) {
        	var Karte = bingo.neueKarte(new Array());
        	if (bingo.config.spielModus == "Hervorgehoben") {
        		var Muster = bingo.createPattern();
        	}
            bingo.placeCard(Karte, Muster);
          	bingo.erstelleSiegchanchen(Karte, Muster);
        }
        
        for(var ememys = 0 ; ememys < bingo.config.gegnerAnzahl; ememys++){
        	var Karte = bingo.neueKarte(new Array());
        	if (bingo.config.spielModus == "Hervorgehoben") {
        		var Muster = bingo.createPattern();
        	}
        	bingo.erstelleSiegchanchen(Karte, Muster, true);
        }
    },

    erstelleSiegchanchen: function(Karte, Muster, isEnemy) {
    	if ((bingo.config.spielModus != "FullCard") && (bingo.config.spielModus != "Hervorgehoben") && (bingo.config.spielModus != "Muster")) {
	        var gewinnmoeglichkeiten = new Array();
	        for (var i = 0; i < 7; i++) {
	            gewinnmoeglichkeiten[i] = new Array();
	            if (i < 5) {
	            	for (var a = 0; a < 5; a++) {
	                    gewinnmoeglichkeiten[i].push(Karte[i + a * 5]);
	                }
	            }
	            if (i == 5) {
	                for (var b = 0; b < 5; b++) {
	                    gewinnmoeglichkeiten[i].push(Karte[b * 6]);
	                }
	            }
	            if (i == 6) {
	                for (var c = 0; c < 5; c++) {
	                    gewinnmoeglichkeiten[i].push(Karte[4 + c * 4]);
	                }
	            }
	        }
	        if (typeof isEnemy == "undefined") {
	        bingo.data.spielerWin.push(gewinnmoeglichkeiten);
	        } else {
	        	bingo.data.gegnerWin.push(gewinnmoeglichkeiten);
	        }
    	}
    	
    	if ((bingo.config.spielModus == "Muster") || (bingo.config.spielModus == "Hervorgehoben")) {
    		var benoetigteZahlen = bingo.data.muster;
    		if (bingo.config.spielModus == "Hervorgehoben"){
    			benoetigteZahlen = Muster;
    		}
    		var gewinnmoeglichkeiten = new Array();
    		gewinnmoeglichkeiten[0] = new Array();
    		for (var i = 0; i < benoetigteZahlen.length; i++) {
    			gewinnmoeglichkeiten[0].push(Karte[benoetigteZahlen[i]]);
    		}
	        if (typeof isEnemy == "undefined") {
		        bingo.data.spielerWin.push(gewinnmoeglichkeiten);
		        } else {
		        	bingo.data.gegnerWin.push(gewinnmoeglichkeiten);
		        }
    	}
    	if (bingo.config.spielModus == "FullCard") {
    		var gewinnmoeglichkeiten = new Array();
    		gewinnmoeglichkeiten[0] = Karte;
	        if (typeof isEnemy == "undefined") {
		        bingo.data.spielerWin.push(gewinnmoeglichkeiten);
		        } else {
		        	bingo.data.gegnerWin.push(gewinnmoeglichkeiten);
		        }
    	}
    },
    
    placeCard: function(Karte, Muster) {
    	var table = $('<table></table>');
        var tablerow = $("<tr></tr>");
        for (var i = 0; i < bingo.data.bingo.length; i++) {
         	var td = $("<td></td>");
         	td.addClass("bingoReihe");
         	td.append(bingo.data.bingo[i]);
         	tablerow.append(td);
        }
        table.append(tablerow);
        
        for (var zeile = 0; zeile < 5; zeile++) {
            var tablerow = $('<tr></tr>');
            for (var spalte = 0; spalte < 5; spalte++) {
            	var td = $("<td></td>");
            	if (Karte[zeile + spalte * 5] == "x") {
            		td.addClass("notClickable");
            	}
            	if (typeof Muster != "undefined") {
                	for (var i = 0; i < Muster.length; i++) {
                    	if ((zeile + (spalte * 5)) == Muster[i]) {
                    		td.addClass("hervorgehoben");
                    	}
                	}
            	}
            	td.append(Karte[zeile + spalte * 5]);
                tablerow.append(td);
            }
            table.append(tablerow);
        }
        $('td', table).not(".bingoReihe").not(".notClickable").addClass('clickables');
        
        $('.clickables', table).click(function () {
        	var clicked = parseInt($(this).text());
       	 	$(this).toggleClass("marked");
            if ($.inArray(clicked, bingo.data.markedNumbers) == - 1) {
            	bingo.data.markedNumbers.push(clicked);
            } else {
            	if ($(this).hasClass("marked") == false) {	 
            		var markedObjekts = $('.marked');
           		 	var alleMarkiertenZahlen = new Array();
           		 	markedObjekts.each(function () {
           		 		var markierteZahl = parseInt($(this).text());
           		 		alleMarkiertenZahlen.push(parseInt(markierteZahl));
           		 	}); 
           		 	var vorhanden = $.inArray(clicked, alleMarkiertenZahlen);
           		 	if (vorhanden == -1) {
           		 		bingo.data.markedNumbers.splice($.inArray(clicked, bingo.data.markedNumbers), 1);
           		 	}
            	}
            }     
        });
        $('body').append(table);
    },
    
    
    createPatternCard: function() {
    	bingo.data.muster = bingo.createPattern();
    	var Karte = bingo.neueKarte(new Array());
    	for(var i = 0; i < bingo.data.muster.length; i++){
    		var index = bingo.data.muster[i];
    		Karte[index] = "x";
    	}
    	bingo.placeCard(Karte);
    },
      
    createPattern: function() {
    	var Felder = new Array();
    	for (var i = 0; i < 5; i++) {
    		var min = i * 5;
    		var max = i * 5 + 4;
    		var nummer = Math.floor(Math.random()*(max-min)+min);
    		Felder.push(nummer);
    	}
    	return Felder;
    },
    
    bestimmeZahlenReihenfolge: function (ZahlenReihenfolge) {
        var nummer = Math.floor(Math.random() * 75) + 1;
        var vorhanden = $.inArray(nummer, ZahlenReihenfolge);
        if (vorhanden == - 1) {
            ZahlenReihenfolge.push(nummer);
        }
        if (ZahlenReihenfolge.length != 75) {
            return bingo.bestimmeZahlenReihenfolge(ZahlenReihenfolge);
        }
        if (ZahlenReihenfolge.length == 75) {
            bingo.config.geladen = true;
            return ZahlenReihenfolge;
        }
    },
    
    neueKarte: function (Karte) {
        var basis = Math.floor(Karte.length / 5);
        var nummer = basis * 15 + Math.floor(Math.random() * 15) + 1;
        var vorhanden = $.inArray(nummer, Karte);
        if (vorhanden == - 1) {
            Karte.push(nummer);
        }
        if (Karte.length < 25) {
            return bingo.neueKarte(Karte);
        } else {
            return Karte;
        }
    },
    
    callNumber: function (index) {
        if (bingo.config.gameover == false) {
            if (bingo.config.geladen == false) {
                console.log('Bitte haben sie einen Moment geduld, es geht gleich los');
            } else {
                if (index != 75) {
                	$("#nummer").html(parseInt(bingo.data.zahlenReihenfolge[index]));
                 	$(".nummer").html(parseInt(bingo.data.zahlenReihenfolge[index]));
                	$(".kugel").css('backgroundColor',bingo.config.randomColor);
                	casinoSpin();
                    bingo.data.drawnNumbers.push(parseInt(bingo.data.zahlenReihenfolge[index]));
                    if (bingo.config.SpielHilfe == 'on') {
                        bingo.aktiviereSpielhilfe();
                    }
                    console.log('Bereits gezogene Nummern:');
                	console.log(bingo.data.drawnNumbers.sort(function(a, b){return a-b}));
                    index = index + 1;
                    bingo.spieleGegner();
                    bingo.progressbar();
                    bingo.config.randomColor = getRandomColor();
    				setTimeout(function(){                				
        				$(".nummer").html("??");
        				$(".zuErscheinendeKugel").css("backgroundColor","");
        				bingo.KugelAnimation(index);
    				}, 1000);
                }
            }
        }
    },  
    
    enemyWins: function() {
    	var random = Math.floor(Math.random() * 3 + 1);
		switch(random) {
			case 1:
				var bild = 'images/gegner1.bmp';
				break;
			case 2:
				var bild = 'images/gegner2.bmp';
				break;
			case 3:
				var bild = 'images/gegner3.bmp';
				break;
		}
		$('#caller').attr('src', bild);
		alert('Das Spiel ist beendet. Ein Gegenspieler hat das Spiel gewonnen!');
		bingo.config.gameover = true;
		window.location.reload(true);
		return false;
    },
    
    
    spieleGegner: function () {
    	if (bingo.config.gameover == false) {
    		var zuErreichendeZahlen = bingo.data.muster;
            var gezogeneNummern = bingo.data.drawnNumbers;
            var gegner = bingo.data.gegnerWin;
            
            for (var a = 0; a < gezogeneNummern.length; a++) {
            	for (var checkedEnemys = 0; checkedEnemys < gegner.length; checkedEnemys++) {
            		//console.log(gegner[checkedEnemys]);  //jeweiliger Gegner mit seiner Gewinnchanche
	            	for (var i = 0; i < gegner[checkedEnemys].length; i++) {
	            	//console.log(gegner[checkedEnemys][i]); //jeweilige Zahlen des Gegners
	            		var gezogen = $.inArray(gezogeneNummern[a], gegner[checkedEnemys][i]);
	            	//console.log(gezogen); //schauen ob die jeweilige Zahl auf der Karte steht
	            		if (gezogen != -1) {
	            			gegner[checkedEnemys][i].splice(gezogen, 1);
	            			console.log(gegner[checkedEnemys][i]);
	            			if (gegner[checkedEnemys][i].length == 0) {
	            				console.log("Gegner hat die Siegesanforderungen erfüllt");
	            				bingo.enemyWins();
	            			}
	            		}
	            	}
	            }
            }
    	}
    },
          
    checkPlayerBingo: function() {
    	if (bingo.config.gameover == false) {
    		var zuErreichendeZahlen = bingo.data.muster;
            var gezogeneNummern = bingo.data.drawnNumbers;
            var markierteZahlen = bingo.data.markedNumbers;
            var karte = bingo.data.spielerWin;
            
            for (var a = 0; a < gezogeneNummern.length; a++) {
            	for (var checkedCards = 0; checkedCards < karte.length; checkedCards++) {
	            	for (var i = 0; i < karte[checkedCards].length; i++) {
	            	//console.log(karte[checkedCards][i]); //jeweilige Zahlen der Karte
	            		var gezogen = $.inArray(gezogeneNummern[a], karte[checkedCards][i]);
	            		var markiert = $.inArray(gezogeneNummern[a], markierteZahlen);
	            	//console.log(gezogen); //schauen ob die jeweilige gezogene Zahl auf der Karte steht
	            	//console.log(markiert); // schauen ob die gezogene Zahl markiert wurde
	            		if ((gezogen != -1) && (markiert != -1)) {
	            			karte[checkedCards][i].splice(gezogen, 1);
	            			console.log(karte[checkedCards][i]);
	            			if (karte[checkedCards][i].length == 0) {
	            				alert("Du hast gewonnen!!");
	            			}
	            		}
	            	}
	            }
            }
    	}
    },
    
    progressbar: function() {
        var zeitspanne = parseInt(bingo.config.ZeitAbstandZiehung) * 1000;
        $('#progress').animate({
            width: '100%'
        }, {
            duration: zeitspanne,
            easing: 'linear',
            complete: function () {
                $('#progress').width(0);
            }
        });
    },
    
  
    KugelAnimation: function(index) {
        	var AnrollendeKugel = $(".zuErscheinendeKugel");
        	AnrollendeKugel.animate({
        		backgroundColor: bingo.config.randomColor
        	}, bingo.config.ZeitAbstandZiehung * 1000 -1100, function () {
            	var AnrollendeKugel = $(".zuErscheinendeKugel");
            	bingo.config.animationCheck = false;
            	AnrollendeKugel.animate({
        			left: "0px"
        		},{
        			duration: 1000,
        			easing: "linear",
        			step: function( pos, fx) {
        				$(".nummer").html("??");
        				if(pos <= 290 && bingo.config.animationCheck == false){
        					bingo.config.animationCheck = true;
        					var Kugel = $(".Kugel");
        	            	Kugel.animate({
        	            		left: "-1000px"
        	            	}, 1000, function() {
        	            		Kugel.css("left","0px");
                				AnrollendeKugel.css("left","");
                				$(".nummer").html("??");
                				$(".zuErscheinendeKugel").css("backgroundColor","");
        	            	});
        	            	var Nummer = $("#nummer");
        	            	Nummer.animate({
        	            		left: "-1000px",
        	            	},1000, function() {
        	            		Nummer.css("left","35px");
        	            		$(".nummer").html("??");
                				$(".zuErscheinendeKugel").css("backgroundColor","");
        	            	});
        				}
        			},
        			complete: function() {
        				bingo.callNumber(index);
        			}
        		 });
            });
        	
        	var Nummer = $(".nummer");
        	Nummer.animate({
        		opacity: "1",
        	},bingo.config.ZeitAbstandZiehung * 1000 + 200, function() {
				setTimeout(function(){                				
					Nummer.css("opacity","0");
				}, 400);
        	});
    },
    
    aktiviereSpielhilfe: function() {
        var zeichenkette2 = bingo.data.drawnNumbers.join(',');
        var zeichenkette = ('Bereits gezogene Zahlen: ');
        $('#spielHilfe').text(zeichenkette + zeichenkette2);
    }
}

$(document).ready(function () {
    bingo.init();
});



//Sammeln der zu wechselnden Elemente ,speichern der Ursprünglichen Zahl,
//Übergabe der jeweiligen Zahl aus der Zahlenkette an die Funktion wechselZahl
function casinoSpin() {
	var elemente = document.getElementsByClassName("zahlWechseln");
	for (var i = 0; i < elemente.length; i++){
		var wunschzahl = elemente[i].innerHTML;
		for (var a = 0; a < wunschzahl.length; a++) {
			var delay = Math.floor(Math.random()*80)+100;
			//console.log(delay);
			wechselZahl(0, parseInt(wunschzahl.substr(a, 1))+(a * 20 + 20), elemente[i], a, delay);
		}
	}
}

//Zahl wird um eins addiert, solange sie kleiner als die Wunschzahl ist, zudem : Aufruf der Funktion tauscheIndexInhalt und Wechselzahl.
//Ansonsten, Wenn wunschzahl erreicht wurde, ersetze Zahllenkette durch erste Zahl der Kette, kein Aufruf tauscheIndexInhalt und wechselzahl mehr
function wechselZahl(zahl, zielZahl, ursprung, index, delay) {
	zahl = zahl + 1;
	if (zahl < zielZahl) {
		setTimeout(function() {
			wechselZahl(zahl, zielZahl, ursprung, index)
		}, delay);
	}
	tauscheIndexInhalt(zahl, ursprung, index);
}

//Ersetze die betroffene Zahl "index" im Array durch die letzte Zahl der Zahlenkette, um dauerhaften wechsel zwischen 0-9 zu haben
function tauscheIndexInhalt(zahl, ursprung, index) {
	var zahlenkette = ursprung.innerHTML.split("");
	zahlenkette[index] = String(zahl).substr(String(zahl).length -1, 1);
	ursprung.innerHTML = zahlenkette.join("");
}

function getRandomColor() {
    var letters = '0123456789ABCDEF'.split('');
    var color = '#';
    for (var i = 0; i < 6; i++ ) {
        color += letters[Math.floor(Math.random() * 16)];
    }
    return color;
}